import YAML from 'yaml'
import Handlebars from 'handlebars';
import merge from 'deepmerge-json';
export function doTemplate(yamlString,args,mergeJson) {
	if(!mergeJson) mergeJson=[]
	mergeJson = unique(mergeJson)
	const template = Handlebars.compile(yamlString)
	const templated = template(args)
	const documents = YAML.parseAllDocuments(templated, {merge: true})
	const jsonDocuments = documents.map(item=>item.toJSON())
	if(merge==undefined) return jsonDocuments
	const newDocuments=[]
	mergeJson.forEach(item=>{
		const yamlDocument=jsonDocuments.find(yamlDocument=>yamlDocument.kind==item.kind)
		if(yamlDocument) jsonDocuments[jsonDocuments.indexOf(yamlDocument)]=merge(yamlDocument,item)
		else newDocuments.push(item)
	})
	return [...jsonDocuments,...newDocuments]
}
function unique(items) {
	return [...new Set(items.map(item=>JSON.stringify(item)))].map(item=>JSON.parse(item))
}
export function toYaml(jsonDocuments) {
	jsonDocuments=unique(jsonDocuments)
	.map(item=>{
		if(jsonDocuments[1] && jsonDocuments[1].namespace && item.metadata && !item.metadata.namespace) item.metadata.namespace=jsonDocuments[1].namespace
		return item;
	})
	jsonDocuments=jsonDocuments.map((yamlDocument,id)=>{
		const remaining=jsonDocuments.slice((jsonDocuments.length-id)*-1)
		remaining.filter(item=>item.kind==yamlDocument.kind && (yamlDocument.merge || item.merge)).forEach(item=>{
			yamlDocument=merge(item, yamlDocument)
			item.merged=true
		})
		delete yamlDocument.merge
		return yamlDocument;
	}).filter(yamlDocument=>!yamlDocument.merged && !yamlDocument.delete)
	//jsonDocuments = jsonDocuments.filter((value, index, self) => index === self.findIndex((t) => (t.kind === value.kind)))
	return jsonDocuments.map(yamlDocument=>YAML.stringify(yamlDocument, {directives: true, defaultStringType: 'QUOTE_DOUBLE', defaultKeyType: 'PLAIN'})).join('')
}