import {doTemplate, toYaml} from './helpers.js'
import {module, waitfor} from './modules.js'
export default async function doContent(content, getTemplate) {
	await waitfor
	if(content.startsWith('---')) return content;
	let yaml = doTemplate(content)
	await module('file',{yaml,getTemplate})
	yaml[0].delete=true
	if(yaml[0].containers) {
		yaml[0].containers=yaml[0].containers.map(async container=>{
			if(!container.template) container.template={}
			await module('container',{container,yaml,getTemplate})
			return container
		})
		yaml[0].containers=await Promise.all(yaml[0].containers)
		yaml.push({kind: 'Deployment',spec: {template:{spec:{
			containers: {
				$append: yaml[0].containers.map(container=>container.template),
			}},
		}}})
		yaml = await doTemplate(await getTemplate('main'),yaml[0], yaml)
	}// else yaml.shift()
	return toYaml(yaml)
}
export async function getConfigTemplate(content, getTemplate) {
	let yaml = doTemplate(content)
	if(!yaml[0].spec.template) return ""
	yaml=await Promise.all(yaml[0].spec.template.spec.containers.map(async container=>{
		return await doTemplate(await getTemplate('config'),{podName: yaml[0].spec.template.metadata.labels.app, ...container})
	}))
	yaml=yaml.flat()
	return toYaml(yaml)
}
