export function file({yaml}) {
    if(yaml[0].disableConfig) return;
    if(!yaml[0].containers) return;
    yaml[0].containers.forEach(container=>{
        const name = `${yaml[0].name}-${container.name}`
        yaml.push({kind: 'Deployment',spec: {template:{spec:{
            volumes: {
                $append: [
                    {
                        name: `${name}-secrets`,
                        secret: {
                            secretName: `${name}`,
                            optional: true
                        }
                    },
                    {
                        name: `${name}-config`,
                        configMap: {
                            name: `${name}`,
                            optional: true
                        }
                    }
                ],
            }},
         }}})
    })
}
export function container({yaml, container}) {
    if(yaml[0].disableConfig) return;
    container.template.volumeMounts = container.template.volumeMounts || []
    container.template.volumeMounts.push({
        name: `${yaml[0].name}-${container.name}-secrets`,
        mountPath: '/secrets',
        readOnly: true
    })
    container.template.volumeMounts.push({
        name: `${yaml[0].name}-${container.name}-config`,
        mountPath: '/config',
        readOnly: true
    })
}
