export async function file({yaml,getTemplate}) {
	if(!yaml[0].ports) return
	yaml.push({
		kind: 'Service',
		apiVersion: 'v1',
		metadata: {
			name: yaml[0].name+'-direct'
		},
		merge: false,
		spec: {
			selector: {
				app: yaml[0].name
			},
			type: 'LoadBalancer',
			externalTrafficPolicy: 'Local',
			sessionAffinity: 'None',
			ports: yaml[0].ports.map(port=>{
				return {
					name: port.name || 'port-'+port.hostPort,
					targetPort: port.port,
					port: port.hostPort,
					protocol: port.protocol || 'TCP'
				}
			}),
			externalIPs: yaml[0].ports.map(port=>port.ip).filter(ip=>!!ip)
		}
	})
}