import {doTemplate} from '../helpers.js'
export async function container({container, yaml, getTemplate}) {
	if(!container.storage) return
	if(!container.template.volumeMounts) container.template.volumeMounts=[]
	container.storage.forEach(async item=>{
		item.volname=yaml[0].name+'-'+item.name
		const volumeMount={
			name: item.volname,
			mountPath: item.path,
			readOnly: !!item.readOnly,
		}
		if(item.subPath) volumeMount.subPath=item.subPath
		container.template.volumeMounts.push(volumeMount)
		let source
		if(!item.hostpath) {
			source={persistentVolumeClaim: {claimName: item.volname}}
			yaml.push(...doTemplate(await getTemplate('pvc'),item))
		} else source={hostPath: {path: item.hostpath}}
		yaml.push({kind: 'Deployment',spec: {template:{spec:{
			volumes: {
				$append: [{
					name: item.volname,
					...source,
				}],
			}},
		}}})
	})
}
